<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2015 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Developer: Brandon Davis (NetriX)
| Website: PHP-Fusion.us
| Dev: PHPFusionMods.org
|  _   _      _        ___  __
| | \ | | ___| |_ _ __(_) \/ /
| |  \| |/ _ \ __| '__| |\  / 
| | |\  |  __/ |_| |  | |/  \ 
| |_| \_|\___|\__|_|  |_/_/\_\
|
| Do not remove the copyright footer without the developers
| consent. You may request the consent of removal by contacting
| me at the following email address: brandon.l.davis@outlook.com
|
| Thank You,
| Brandon (NetriX)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES . "templates/admin_header.php";
require_once "functions.php";
opentable("Fusion Tools <div style='float:right;'>Build 0.70</div>");
require_once "nav.php";
$database_optimized = dbquery("SELECT value FROM " . DB_PREFIX . "optimize WHERE name='database_optimized'");
$database_optimized = dbresult($database_optimized, 0);
$query              = dbquery("SHOW TABLE STATUS");
$dbSize             = 0;
while ($row = dbarray($query)) {
    $dbSize += $row["Data_length"] + $row["Index_length"];
}
if (isset($_POST['process'])) {
    isset($_POST['removeArticleDrafts']) ? deleteDraftArticle() : "";
    isset($_POST['removeNewsDrafts']) ? deleteDraftNews() : "";
    isset($_POST['removeUnapprovedMembers']) ? deleteUnapprovedMembers() : "";
    isset($_POST['deleteUserLogs']) ? deleteUserLogs() : "";
    isset($_POST['deleteErrorLogs']) ? deleteErrorLogs() : "";
    isset($_POST['optimizeDatabase']) ? optimizeDatabase() : "";
    isset($_POST['fixForumPost']) ? fixForumPosts() : "";
    $queryOp  = dbquery("SHOW TABLE STATUS");
    $dbSizeOp = 0;
    while ($rowOp = dbarray($queryOp)) {
        $dbSizeOp += $rowOp["Data_length"] + $rowOp["Index_length"];
    }
    $diff       = ($dbSize - $dbSizeOp);
    $totalSaved = dbquery("UPDATE " . DB_PREFIX . "optimize SET value=value+{$diff} WHERE name='database_optimized'");
    dbquery("UPDATE " . DB_PREFIX . "optimize SET value='" . time() . "' WHERE name='last_optimized'");
    $database_optimized = dbquery("SELECT value FROM " . DB_PREFIX . "optimize WHERE name='database_optimized'");
    $database_optimized = dbresult($database_optimized, 0);
    $query              = dbquery("SHOW TABLE STATUS");
    $dbSize             = 0;
    while ($row = dbarray($query)) {
        $dbSize += $row["Data_length"] + $row["Index_length"];
    }
}
$articleDrafts          = dbcount("(article_id)", DB_ARTICLES, "article_draft='1'");
$newsDrafts             = dbcount("(news_id)", DB_NEWS, "news_draft='1'");
$unapprovedMembers      = dbcount("(user_id)", DB_USERS, "user_status='2'");
$userLogs               = dbcount("(userlog_id)", DB_USER_LOG);
$errorLogs              = dbcount("(error_id)", DB_ERRORS);
$optimizationsProcessed = dbquery("SELECT value FROM " . DB_PREFIX . "optimize WHERE name='total_processed'");
$optimizationsProcessed = dbresult($optimizationsProcessed, 0);
$last_optimized         = dbquery("SELECT value FROM " . DB_PREFIX . "optimize WHERE name='last_optimized'");
$last_optimized         = dbresult($last_optimized, 0);
$posts_optimized        = dbquery("SELECT value FROM " . DB_PREFIX . "optimize WHERE name='posts_optimized'");
$posts_optimized        = dbresult($posts_optimized, 0);
echo "<form name='form_optimize' id='form_optimize' method='post' action='" . FUSION_SELF . $aidlink . "' enctype='multipart/form-data'>\n";
echo "<table style='width: 100%; text-align:left; line-height: 20px' class='tbl' cellspacing='0'>
<tr>
<td style='width: 33%; vertical-align:top' class='tbl1'>
<span style='font-size: 14px; font-weight: bold;'>Clean-up options</span><hr />
<input type='checkbox' name='removeArticleDrafts'> Remove article drafts ({$articleDrafts} Found)<br />
<input type='checkbox' name='removeNewsDrafts'> Remove news drafts ({$newsDrafts} Found)<br />
<input type='checkbox' name='removeUnapprovedMembers'> Remove unapproved members ({$unapprovedMembers} Found)<br />
<input type='checkbox' name='deleteUserLogs'> Clean user log ({$userLogs} Found)<br />
<input type='checkbox' name='deleteErrorLogs'> Clean error log ({$errorLogs} Found)
</td>
<td style='width: 33%; vertical-align:top' class='tbl1'>
<span style='font-size: 14px; font-weight: bold;'>Actions</span><hr />
<input type='checkbox' name='fixForumPost' checked> Fix forum last posts<br />
<input type='checkbox' name='optimizeDatabase' checked> Optimize database tables<br />
<input type='checkbox' name='restoreFusion'> Restore default PHP-Fusion settings<br />
<input type='checkbox' name='netrixOptimize'> Use NetriX's optimized settings
</td>
<td style='width: 34%; vertical-align:top' class='tbl1'>
<span style='font-size: 14px; font-weight: bold;'>Details</span><hr />
<strong>Last optimization:</strong> " . showdate("longdate", $last_optimized) . "<br />
<strong>Optimizations processed:</strong> {$optimizationsProcessed}<br />
<strong>Current database size:</strong> " . parsebytesize($dbSize) . "<br />
<strong>Total database optimized:</strong> " . parsebytesize($database_optimized) . "<br />
<strong>Forum Posts Fixed:</strong> {$posts_optimized}<br />
</td>\n</tr>\n";
echo "<tr>\n<td style='width: 100%; text-align: center;' colspan='3' class='tbl1'>
<input type='submit' class='button' style='text-transform:uppercase' name='process' value='Optimize!' />";
echo "</td>\n</tr>\n</table>";
echo "</form>";
closetable();
require_once THEMES . "templates/footer.php";