<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2015 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Developer: Brandon Davis (NetriX)
| Website: PHP-Fusion.us
| Dev: PHPFusionMods.org
|  _   _      _        ___  __
| | \ | | ___| |_ _ __(_) \/ /
| |  \| |/ _ \ __| '__| |\  / 
| | |\  |  __/ |_| |  | |/  \ 
| |_| \_|\___|\__|_|  |_/_/\_\
|
| Do not remove the copyright footer without the developers
| consent. You may request the consent of removal by contacting
| me at the following email address: brandon.l.davis@outlook.com
|
| Thank You,
| Brandon (NetriX)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
/*
 * eCheck Seciruty v1.0 beta
 * Copyright 2010 Miroslav Yovchev aka SecretR - free-source.net
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
require_once "../../maincore.php";
require_once THEMES . "templates/admin_header.php";
opentable("Fusion Tools - Security Scan <div style='float:right;'>Build 0.70</div>");
$version         = '1.1';
$self            = basename(__FILE__);
$eroot           = '../../';
$print_infected  = true;
$print_suspected = true;
$print_all       = false;
$recurse         = 100;
require_once "nav.php";
echo "<table style='width: 100%; text-align:left; line-height: 20px' class='tbl' cellspacing='0'>
<tr>
<td style='vertical-align:top; line-height: 20px' class='tbl1'>
<span style='font-size: 14px; font-weight: bold;'>Security Scan</span><hr />";
print "<pre>";
$fl                = new e_file();
$tree              = $fl->get_files($eroot, '\.php|\.sc|.bb|\.gif', 'standard', $recurse);
$counter_infected  = 0;
$counter_cleaned   = 0;
$counter_suspected = 0;
$counter_error     = 0;
$counter_warning   = 0;
// just in case
set_time_limit(60);
error_reporting(E_ALL);
foreach ($tree as $finfo) {
    // exclude self
    if (strpos($finfo['fname'], $self) !== FALSE && realpath(__FILE__) == realpath($finfo['path'] . $finfo['fname'])) {
        continue;
    }
    if ($print_all)
        print "{$finfo['path']}{$finfo['fname']}....CHECKING";
    $tmp = file_get_contents($finfo['path'] . $finfo['fname']);
    preg_match('/[^.\s]*([a-z])$/i', $finfo['fname'], $match);
    if (preg_match('/[^.\s]*([a-z])$/i', $finfo['fname'], $match)) {
        $ext = $match[0];
        unset($match);
    }
    ///<\?(php)?/i - short tag detection problem
    if ('gif' == $ext && preg_match('/<\?php/i', $tmp)) {
        $counter_infected++;
        $counter_error++;
        if ($print_infected)
            print "{$finfo['path']}{$finfo['fname']}";
        if ($print_infected || $print_all) {
            print "...INFECTED (PHP open tag inside GIF image)";
            print("\n\ERROR: {$finfo['path']}{$finfo['fname']} will not be auto-deleted, you have to delete it manually if you think it's a threat!\n\n");
        }
    }
    // known infection - can be auto-cleaned
    elseif (preg_match('#^(.*)<\?php(.*)eval(\s*)\((\s*)base64_decode(\s*)\((\s*)(.*)(\?><\?php)*\n#i', $tmp, $matches)) {
        if ($print_infected)
            print "{$finfo['path']}{$finfo['fname']}";
        if ($print_infected || $print_all)
            print "...INFECTED";
        $counter_infected++;
        $counter_error++;
        print("\n\ERROR: {$finfo['path']}{$finfo['fname']} will NOT BE CLEANED! Please use the shell version of this script.\n\n");
        continue;
    }
    // just a guess - eval(base64_decode(... pattern match 
        elseif (preg_match('#eval(\s*)\((.*)base64_decode(\s*)\(#i', $tmp)) {
        if ($print_suspected)
            print "{$finfo['path']}{$finfo['fname']}";
        if ($print_suspected || $print_all)
            print "...SUSPECTED (eval/base64_decode found)";
        $counter_suspected++;
        if ($print_suspected || $print_all)
            print "\n";
    }
    // Found inside the compromised e107 full release (class2.php)
        elseif (preg_match('/\$_COOKIE\[[\'|"]access-admin[\'|"]\]/i', $tmp)) {
        if ($print_infected)
            print "{$finfo['path']}{$finfo['fname']}";
        if ($print_infected || $print_all) {
            print "...INFECTED (access-admin COOKIE reference)\n";
        }
        print("\nERROR: {$finfo['path']}{$finfo['fname']} can't be auto-cleaned!\n\n");
        $counter_infected++;
        $counter_error++;
        continue;
    }
    // Just search for shell execution here, it'll also match some clean core files
        elseif (preg_match('/([^a-z0-9_>])(shell_exec(\s*)\(|system(\s*)\(|exec(\s*)\(|passthru(\s*)\()/i', $tmp)) {
        if ($print_suspected)
            print "{$finfo['path']}{$finfo['fname']}";
        if ($print_suspected || $print_all)
            print "...SUSPECTED (shell execution)\n";
        $counter_suspected++;
    } elseif ($print_all)
        print "...OK\n";
    unset($tmp);
}
echo "\n";
print "Files checked: " . count($tree) . "\n";
print "Files suspected: " . $counter_suspected . "\n";
print "Files infected: " . $counter_infected . "\n";
print "Files cleaned: " . $counter_cleaned . "\n";
print "Clean errors: " . $counter_error . "\n";
print "Clean warnings: " . $counter_warning . "\n\n";
if ($counter_suspected)
    print "NOTE: SUSPECTED DOESN'T MEAN INFECTED! DIFF AGAINST TRUSTED COPY OF SUSPECTED FILES TO BE SURE EVERYTHING IS OK. \n\n";
print "</pre>";
class e_file
{
    function get_files($path, $fmask = '', $omit = 'standard', $recurse_level = 0, $current_level = 0)
    {
        $ret = array();
        if ($recurse_level != 0 && $current_level > $recurse_level) {
            return $ret;
        }
        if (substr($path, -1) == '/') {
            $path = substr($path, 0, -1);
        }
        if (!$handle = opendir($path)) {
            return $ret;
        }
        if ($omit == 'standard') {
            $rejectArray = array(
                '^\.$',
                '^\.\.$',
                '^\/$',
                '^CVS$',
                'thumbs\.db',
                '.*\._$',
                '^\.htaccess$',
                'index\.html',
                'null\.txt'
            );
        } else {
            if (is_array($omit)) {
                $rejectArray = $omit;
            } else {
                $rejectArray = array(
                    $omit
                );
            }
        }
        while (false !== ($file = readdir($handle))) {
            if (is_dir($path . '/' . $file)) {
                if ($file != '.' && $file != '..' && $file != 'CVS' && $recurse_level > 0 && $current_level < $recurse_level) {
                    $xx  = $this->get_files($path . '/' . $file, $fmask, $omit, $recurse_level, $current_level + 1);
                    $ret = array_merge($ret, $xx);
                }
            } elseif ($fmask == '' || preg_match("#" . $fmask . "#i", $file)) {
                $rejected = FALSE;
                foreach ($rejectArray as $rmask) {
                    if (preg_match("#" . $rmask . "#", $file)) {
                        $rejected = TRUE;
                        break;
                    }
                }
                if ($rejected == FALSE) {
                    $finfo['path']  = $path . "/"; // important: leave this slash here and update other file instead.
                    $finfo['fname'] = $file;
                    $ret[]          = $finfo;
                }
            }
        }
        return $ret;
    }
    function get_dirs($path, $fmask = '', $omit = 'standard')
    {
        $ret = array();
        if (substr($path, -1) == '/') {
            $path = substr($path, 0, -1);
        }
        if (!$handle = opendir($path)) {
            return $ret;
        }
        if ($omit == 'standard') {
            $rejectArray = array(
                '^\.$',
                '^\.\.$',
                '^\/$',
                '^CVS$',
                'thumbs\.db',
                '.*\._$'
            );
        } else {
            if (is_array($omit)) {
                $rejectArray = $omit;
            } else {
                $rejectArray = array(
                    $omit
                );
            }
        }
        while (false !== ($file = readdir($handle))) {
            if (is_dir($path . '/' . $file) && ($fmask == '' || preg_match("#" . $fmask . "#", $file))) {
                $rejected = FALSE;
                foreach ($rejectArray as $rmask) {
                    if (preg_match("#" . $rmask . "#", $file)) {
                        $rejected = TRUE;
                        break;
                    }
                }
                if ($rejected == FALSE) {
                    $ret[] = $file;
                }
            }
        }
        return $ret;
    }
    function rmtree($dir)
    {
        if (substr($dir, strlen($dir) - 1, 1) != '/') {
            $dir .= '/';
        }
        if ($handle = opendir($dir)) {
            while ($obj = readdir($handle)) {
                if ($obj != '.' && $obj != '..') {
                    if (is_dir($dir . $obj)) {
                        if (!$this->rmtree($dir . $obj)) {
                            return false;
                        }
                    } elseif (is_file($dir . $obj)) {
                        if (!unlink($dir . $obj)) {
                            return false;
                        }
                    }
                }
            }
            closedir($handle);
            if (!@rmdir($dir)) {
                return false;
            }
            return true;
        }
        return false;
    }
}
echo "</td>
</tr>
</table>";
closetable();
require_once THEMES . "templates/footer.php";